#include <ESP8266WiFi.h>
 
const char* ssid = "inserisci il nome (SSID) della tua rete WiFi"; // fill in here your router or wifi SSID
const char* password = "inserisci la password della tua rete WiFi"; // fill in here your router or wifi password
 #define RELAY 0 // relay connected to  GPIO0
WiFiServer server(80);

int changeVal = 1;   //if cangeVal = "1", relay1on = HIGH; relay1off = LOW; else relay1on = LOW; relay1off = HIGH
//It is useful if you use commercial a relay, which inverted state.
int relay1on;
int relay1off;
 
void setup() 
{
  Serial.begin(115200); // must be same baudrate with the Serial Monitor

  if (changeVal == 1){
    relay1on = 1;
    relay1off = 0;
  }    
  else{
    relay1on = 0;
    relay1off = 1;  
  }
 
  pinMode(RELAY,OUTPUT);
  digitalWrite(RELAY, relay1off);
 
  // Connect to WiFi network
  Serial.println();
  Serial.println();
  Serial.print("Connecting to ");
  Serial.println(ssid);
 
  WiFi.begin(ssid, password);
 
  while (WiFi.status() != WL_CONNECTED) 
  {
    delay(500);
    Serial.print(".");
  }
  Serial.println("");
  Serial.println("WiFi connected");
 
  // Start the server
  server.begin();
  Serial.println("Server started");
 
  // Print the IP address
  Serial.print("Use this URL to connect: ");
  Serial.print("https://");
  Serial.print(WiFi.localIP());
  Serial.println("/");
 delay(3000);
}
 
void loop() 
{
  // Check if a client has connected
  WiFiClient client = server.available();
  if (!client) 
  {
    return;
  }
 
  // Wait until the client sends some data
  Serial.println("new client");
  while(!client.available())
  {
    delay(1);
  }

  // Read the first line of the request
  String request = client.readStringUntil('\r');
  Serial.println(request);
  client.flush();
 
  // Match the request
  int value = relay1on;
  if (request.indexOf("/RELAY=ON") != -1)  
  {
    Serial.println("RELAY=ON");
    digitalWrite(RELAY,relay1on);
    value = relay1on;
  }
  if (request.indexOf("/RELAY=OFF") != -1)  
  {
    Serial.println("RELAY=OFF");
    digitalWrite(RELAY,relay1off);
    value = relay1off;
  }
  
  //Display the HTML web page
  client.println("HTTP/1.1 200 OK");
  client.println("Content-Type: text/html");
  client.println(""); //  this is a must
  client.println("<!DOCTYPE HTML>");
  client.println("<html>");
  client.println("<head><meta name=\"viewport\" content=\"width=device-width, initial-scale=1\">");
  client.println("<title>ESP8266 RELAY Control</title>");
  client.println("<style>html { font-family: Helvetica; display: inline-block; margin: 0px auto; text-align: center;}");
  client.println(".button { background-color: #195B6A; border: none; color: white; padding: 16px 40px;");
  client.println("text-decoration: none; font-size: 30px; margin: 2px; cursor: pointer;}");
  client.println(".button2 {background-color: #77878A;}</style>");
  client.println("</head>");
  client.println("<body>");
  client.println("<body>");
  client.println("<h1 align = center>ESP01 RELAY CONTROL</h1>");
  client.print("<h2 align = center>RELAY STATUS: ");
 
  if(value == relay1off) 
  {
    client.print("OFF");
  } 
  else 
  {
    client.print("ON");
  }
  client.println("</h2>");
  client.println("<br>");
  client.println("<a href=\"/RELAY=ON\"><button class=\"button\">TURN ON</button></a>");
  client.println("<a href=\"/RELAY=OFF\"><button class=\"button button2\">TURN OFF</button></a><br>");
  client.println("</body>");
  client.println("</html>");
 
  delay(1);
  Serial.println("Client disconnected");
  Serial.println("");
}
